//
//  SettingsViewController.swift
//  SampleAppLiveVideo
//
//  Created by Nutchaphon Rewik on 27/4/2564 BE.
//  Copyright © 2564 BE Eko. All rights reserved.
//

import UIKit

class SettingsViewController: UIViewController {

    @IBOutlet weak var apiKeyTextField: UITextField!
    @IBOutlet weak var saveButton: UIButton!
    
    @IBOutlet weak var httpUrlTextField: UITextField!
    @IBOutlet weak var rpcUrlTextField: UITextField!
    @IBOutlet weak var mqttURLTextField: UITextField!
    
    override func viewDidLoad() {
        super.viewDidLoad()
        apiKeyTextField.text = AppManager.shared.getAPIKey()
        [apiKeyTextField, httpUrlTextField, mqttURLTextField, rpcUrlTextField].forEach{ $0?.delegate = self }
        
        let urlInfo = AppManager.shared.getUrlInfo()
        httpUrlTextField.text = urlInfo.0
        rpcUrlTextField.text = urlInfo.1
        mqttURLTextField.text = urlInfo.2
        
        saveButton.addTarget(self, action: #selector(onSaveButtonTap), for: .touchUpInside)
        
        let tapGesture = UITapGestureRecognizer(target: self, action: #selector(dismissKeyboard))
        self.view.addGestureRecognizer(tapGesture)
    }
    
    @IBAction func apiKeyTextFieldEditingChanged() {
        AppManager.shared.saveAPIKey(apiKeyTextField.text ?? "")
    }
    
    @objc func dismissKeyboard() {
        view.endEditing(true)
    }
    
    @objc func onSaveButtonTap() {
        dismissKeyboard()
        AppManager.shared.saveUrlInfo(httpURL: httpUrlTextField.text ?? "", rpcURL: rpcUrlTextField.text  ?? "", mqttURL: mqttURLTextField.text ?? "")
        AppManager.shared.setup { _,_ in
            NotificationCenter.default.post(name: Notification.Name.updateUser, object: nil)
        }
        
    }
}

extension SettingsViewController: UITextFieldDelegate {
    
    func textFieldShouldReturn(_ textField: UITextField) -> Bool {
        textField.resignFirstResponder()
        return true
    }
    
}
